﻿Imports System.ComponentModel
Imports System.IO.Ports
Imports System.Threading

Public Class Form1
    Dim Buffer As String
    Delegate Sub SetTextCallback([text] As String)
    Private demoThread As Thread = Nothing
    Dim State As String
    Const T_out As Integer = 2000
    Dim BTver As String

    Public Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim i As Integer
        Try
            For i = 0 To My.Computer.Ports.SerialPortNames.Count - 1
                Cmb_port.Items.Add(My.Computer.Ports.SerialPortNames(i))
                If GetSetting("HCprogram", "options", "COM", "") = My.Computer.Ports.SerialPortNames(i) Then Cmb_port.SelectedIndex = i
            Next
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        For i = 0 To Cmb_baud.Items.Count - 1
            If GetSetting("HCprogram", "options", "Baud", "9600") = Cmb_baud.Items(i) Then Cmb_baud.SelectedIndex = i
        Next
        CheckModuleOnConnectToolStripMenuItem.Checked = GetSetting("HCprogram", "options", "Check", False)
        AddHandler Serial1.DataReceived, AddressOf Me.DataReceivedHandler
    End Sub

    Private Sub Bt_connect_Click(sender As Object, e As EventArgs) Handles Bt_connect.Click

        If Cmb_port.Text = "" Then MsgBox("Select COM first", vbExclamation) : Cmb_port.Focus() : Exit Sub
        If Cmb_baud.Text = "" Then MsgBox("Select Baud rate first", vbExclamation) : Cmb_baud.Focus() : Exit Sub
        Serial1.PortName = Cmb_port.Text
        Serial1.BaudRate = Cmb_baud.Text
        Serial1.ReadTimeout = 2000

        Try
            Serial1.Open()
            T_log.Text += "*Serial open*" & vbCrLf
            Bt_disconnect.Enabled = True : Bt_connect.Enabled = False
            Dim stopwatch As Stopwatch = Stopwatch.StartNew
            Thread.Sleep(10)
            stopwatch.Stop()

            If CheckModuleOnConnectToolStripMenuItem.Checked Then
                State = "CHK"
                Timout.Interval = T_out : Timout.Enabled = True
                Serial1.Write("AT")
                TStatus.Text = "Check module"
            Else
                TStatus2.Text = "Connected" : GrCMD.Enabled = True
            End If

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub Bt_disconnect_Click(sender As Object, e As EventArgs) Handles Bt_disconnect.Click
        If Serial1.IsOpen Then Serial1.Close()
        Bt_disconnect.Enabled = False : Bt_connect.Enabled = True
        T_log.Text += "*Disconnected*" & vbCrLf
        TStatus2.Text = "Disconnected"
        Timout.Enabled = False : GrCMD.Enabled = False : State = ""
    End Sub

    Private Sub Pic_refresh_Click(sender As Object, e As EventArgs) Handles Pic_refresh.Click
        Dim i As Integer
        Cmb_port.Items.Clear()

        Try
            For i = 0 To My.Computer.Ports.SerialPortNames.Count - 1
                Cmb_port.Items.Add(My.Computer.Ports.SerialPortNames(i))
            Next
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Bt_AT.Click
        If Serial1.IsOpen = False Then Bt_disconnect_Click(vbNull, EventArgs.Empty) : Exit Sub
        State = "AT" : Timout.Interval = T_out : Timout.Enabled = True
        TStatus.Text = "Send AT command"
        Serial1.Write("AT")
    End Sub

    Private Sub DataRead()
        Me.SetText(Buffer & vbCrLf)
    End Sub

    Public Sub DataReceivedHandler(sender As Object, e As SerialDataReceivedEventArgs)
        Dim sp As SerialPort = CType(sender, SerialPort)

        Buffer = ""

        Do While sp.BytesToRead > 0
            Buffer += sp.ReadExisting()
        Loop

        Me.demoThread = New Thread(New ThreadStart(AddressOf DataRead))
        Me.demoThread.Start()

    End Sub

    Private Sub SetText(ByVal [text] As String)
        If Me.T_log.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf SetText)
            Me.Invoke(d, New Object() {[text]})
        Else
            Me.T_log.Text += [text]
        End If
        Try
            Select Case State
                Case "CHK"
                    If InStr([text], "OK") > 0 Then TStatus.Text = "Module correctly connected" : Timout.Enabled = False : GrCMD.Enabled = True : TStatus2.Text = "Connected"
                Case "AT"
                    If InStr([text], "OK") > 0 Then TStatus.Text = "Command confirmed" : Timout.Enabled = False
                Case "VER"
                    If InStr([text], "OK") > 0 Then
                        TStatus.Text = "Command confirmed" : Timout.Enabled = False
                        BTver = Strings.Right([text], Len([text]) - InStrRev([text], "V"))
                        TStatusVer.Text = "v." & BTver.Replace(vbCr, "").Replace(vbLf, "")
                    End If
                Case "PIN"
                    If InStr([text], "OK") > 0 Then TStatus.Text = "Command confirmed" : Timout.Enabled = False
                Case "BAUD"
                    If InStr([text], "OK") > 0 Then TStatus.Text = "Command confirmed" : Timout.Enabled = False
                Case "NAME"
                    If InStr([text], "OK") > 0 Then TStatus.Text = "Command confirmed" : Timout.Enabled = False
                Case "PAR"
                    If InStr([text], "OK") > 0 Then TStatus.Text = "Command confirmed" : Timout.Enabled = False
            End Select
            State = ""
        Catch ex As Exception
        End Try
    End Sub

    Private Sub Cmb_port_SelectedIndexChanged(sender As Object, e As EventArgs) Handles Cmb_port.SelectedIndexChanged
        SaveSetting("HCprogram", "options", "COM", Cmb_port.Text)

    End Sub

    Private Sub Cmb_baud_SelectedIndexChanged(sender As Object, e As EventArgs) Handles Cmb_baud.SelectedIndexChanged
        SaveSetting("HCprogram", "options", "Baud", Cmb_baud.Text)
    End Sub

    Private Sub Cmb_port_KeyPress(sender As Object, e As KeyPressEventArgs) Handles Cmb_port.KeyPress, Cmb_baud.KeyPress, Cmb_parity.KeyPress, Cmb_setBaud.KeyPress
        e.Handled = True
    End Sub

    Private Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Me.Closing
        Timout.Enabled = False
        If Serial1.IsOpen Then Serial1.Close()
    End Sub

    Private Sub Tb_pin_KeyPress(sender As Object, e As KeyPressEventArgs) Handles Tb_pin.KeyPress
        If Asc(e.KeyChar) <> 8 AndAlso Not IsNumeric(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub

    Private Sub Bt_ATver_Click(sender As Object, e As EventArgs) Handles Bt_ATver.Click
        If Serial1.IsOpen = False Then Bt_disconnect_Click(vbNull, EventArgs.Empty) : Exit Sub
        State = "VER" : Timout.Interval = T_out : Timout.Enabled = True
        TStatus.Text = "Send AT+VERSION command"
        Serial1.Write("AT+VERSION")
    End Sub

    Private Sub Bt_setBaud_Click(sender As Object, e As EventArgs) Handles Bt_setBaud.Click
        If Serial1.IsOpen = False Then Bt_disconnect_Click(vbNull, EventArgs.Empty) : Exit Sub
        State = "BAUD" : Timout.Interval = T_out : Timout.Enabled = True
        TStatus.Text = "Send AT+BAUD command"

        Select Case Cmb_setBaud.Text
            Case "1200"
                Serial1.Write("AT+BAUD1")
            Case "2400"
                Serial1.Write("AT+BAUD2")
            Case "4800"
                Serial1.Write("AT+BAUD3")
            Case "9600"
                Serial1.Write("AT+BAUD4")
            Case "19200"
                Serial1.Write("AT+BAUD5")
            Case "38400"
                Serial1.Write("AT+BAUD6")
            Case "57600"
                Serial1.Write("AT+BAUD7")
            Case "115200"
                Serial1.Write("AT+BAUD8")
            Case "230400"
                Serial1.Write("AT+BAUD9")
            Case "460800"
                Serial1.Write("AT+BAUDA")
            Case "921600"
                Serial1.Write("AT+BAUDB")
            Case "1382400"
                Serial1.Write("AT+BAUDC")
        End Select

    End Sub

    Private Sub Bt_setName_Click(sender As Object, e As EventArgs) Handles Bt_setName.Click
        If Len(Tb_Name.Text) < 4 Then Exit Sub
        If Serial1.IsOpen = False Then Bt_disconnect_Click(vbNull, EventArgs.Empty) : Exit Sub
        State = "NAME" : Timout.Interval = T_out : Timout.Enabled = True
        TStatus.Text = "Send AT+NAME command"
        Serial1.Write("AT+NAME" & Tb_Name.Text)
    End Sub

    Private Sub Bt_setPin_Click(sender As Object, e As EventArgs) Handles Bt_setPin.Click
        If Len(Tb_pin.Text) < 4 Then Exit Sub
        If Serial1.IsOpen = False Then Bt_disconnect_Click(vbNull, EventArgs.Empty) : Exit Sub
        State = "PIN" : Timout.Interval = T_out : Timout.Enabled = True
        TStatus.Text = "Send AT+PIN command"
        Serial1.Write("AT+PIN" & Tb_pin.Text)
    End Sub

    Private Sub Bt_setParity_Click(sender As Object, e As EventArgs) Handles Bt_setParity.Click
        If Serial1.IsOpen = False Then Bt_disconnect_Click(vbNull, EventArgs.Empty) : Exit Sub
        State = "PAR" : Timout.Interval = T_out : Timout.Enabled = True
        TStatus.Text = "Send AT parity command"
        Select Case Cmb_parity.Text
            Case "No parity"
                Serial1.Write("AT+PN")
            Case "Odd parity"
                Serial1.Write("AT+PO")
            Case "Even parity"
                Serial1.Write("AT+PE")
        End Select
    End Sub

    Private Sub Timout_Tick(sender As Object, e As EventArgs) Handles Timout.Tick
        Timout.Enabled = False
        If State = "CHK" Then TStatus.Text = "No response from module." : Bt_disconnect_Click(vbNull, EventArgs.Empty) : Exit Sub
        TStatus.Text = "No ACK recived."
    End Sub

    Private Sub T_log_KeyPress(sender As Object, e As KeyPressEventArgs) Handles T_log.KeyPress
        e.Handled = True
    End Sub

    Private Sub CheckModuleOnConnectToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles CheckModuleOnConnectToolStripMenuItem.Click
        If CheckModuleOnConnectToolStripMenuItem.Checked Then CheckModuleOnConnectToolStripMenuItem.Checked = False Else CheckModuleOnConnectToolStripMenuItem.Checked = True
        SaveSetting("HCprogram", "options", "Check", CheckModuleOnConnectToolStripMenuItem.Checked)
    End Sub

    Private Sub ExitToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ExitToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub ToolStripMenuItem1_Click(sender As Object, e As EventArgs) Handles ToolStripMenuItem1.Click
        AboutBox.ShowDialog(Me)
    End Sub

End Class
